#include "commandUtils.h"
#include <fcntl.h>
#define READ 0
#define WRITE 1

FILE* executeCommand(const char* command, const char* mode)
{
 

	int *outfp=malloc(sizeof(int));
	int *infp=malloc(sizeof(int));
int p_stdin[2], p_stdout[2];
    pid_t pid;

    if (pipe(p_stdin) != 0 || pipe(p_stdout) != 0)
        return -1;
	
    pid = fork();
fcntl(p_stdout, F_SETFL, O_NONBLOCK);
fcntl(p_stdin, F_SETFL, O_NONBLOCK);
    if (pid < 0)
        return 0;
    else if (pid == 0)
    {
        close(p_stdin[WRITE]);
        dup2(p_stdin[READ], READ);
        close(p_stdout[READ]);
        dup2(p_stdout[WRITE], WRITE);

        execl("/bin/bash", "bash", "-c", command, NULL);
        perror("execl");
        exit(1);
    }else
{

    if (infp == NULL)
        close(p_stdin[WRITE]);
    else
        *infp = p_stdin[WRITE];

    if (outfp == NULL)
        close(p_stdout[READ]);
    else
        *outfp = p_stdout[READ];
   close(p_stdin[WRITE]);
   close(p_stdout[WRITE]);
   free(infp);
   return fdopen(*outfp,"r");
}
    


}

void closeCommand(FILE * file)
{
  fclose(file); 
  free(file); 
}
