#include <gtk/gtk.h>
#include <string.h>
#include <stdlib.h>
#include <glib.h>
#include <stdio.h>
#include "generateParameter.h"
#include "applicationGUI.h"
#include "widgetOperations.h"
#include "main.h"


//void pclose(FILE* f);


int  addManyUsers_tests();
int performTests(int manyUsers);

char *replace(char *st, char *orig, char *repl);
gchar* expireDate(gchar* c);



struct sParameter* createParameterStructure( enum field f,  const char *parameter, int type)
{
        struct sParameter * parameterStruct=malloc(sizeof(struct sParameter));
        parameterStruct->f=f;
	    char*temp=malloc(5);
		strcpy(temp,parameter);
        parameterStruct->parameter=temp;
        parameterStruct->type=type;
        return parameterStruct;
}
GSList * initializeParameter()
{
        GSList * parameterList=0;
        parameterList=g_slist_append(parameterList, (gpointer)createParameterStructure(USERNAME, "", TEXT));        
        parameterList=g_slist_append(parameterList, (gpointer)createParameterStructure(PASSWORD, "-p", TEXT));
        parameterList=g_slist_append(parameterList, (gpointer)createParameterStructure(FULLNAME, "-c", TEXT));
        parameterList=g_slist_append(parameterList, (gpointer)createParameterStructure(FOLDER, "-d", TEXT));
        parameterList=g_slist_append(parameterList, (gpointer)createParameterStructure(CREATEFOLDER, "-m", BOOLEAN));
        parameterList=g_slist_append(parameterList,(gpointer)createParameterStructure(GROUPS, "-G", LIST));
        parameterList=g_slist_append(parameterList, (gpointer)createParameterStructure(SHELL, "-s", TEXT));
        parameterList=g_slist_append(parameterList, (gpointer)createParameterStructure(UID, "-u", INTEGER));
        parameterList=g_slist_append(parameterList, (gpointer)createParameterStructure(UNIQUEID, "-o", BOOLEAN));
        parameterList=g_slist_append(parameterList, (gpointer)createParameterStructure(CREATEUSERGROUP, "-U", BOOLEAN));
        parameterList=g_slist_append(parameterList, (gpointer)createParameterStructure(EXPIREDATE, "-e", TEXT));
        
        return parameterList;
        
             
}
void concatenateTextParameter(char* dest, struct sParameter* sP, sUser* user)
{
        if (strcmp(getUserInfo(user,sP->f), "")!=0)
	{
	  strcat(dest," ");
	  strcat(dest,sP->parameter);
	  strcat(dest," ");
	  strcat(dest,getUserInfo(user,sP->f));
	  strcat(dest," ");
	}
}
void concatenateBooleanParameter(char* dest, struct sParameter* sP, sUser* user)
{
  
        if (getUserInfoI(user,sP->f))
        {
                strcat(dest," ");
                strcat(dest,sP->parameter);
                strcat(dest," ");
        }
}
void concatenateIntegerParameter(char* dest, struct sParameter* sP, sUser* user)
{
	if (getUserInfoI(user,sP->f)!=-1)
	{
	  char* a=malloc(20);
	  sprintf(a,"%d",getUserInfoI(user,sP->f));        
	  strcat(dest," ");
	  strcat(dest,sP->parameter);
	  strcat(dest," ");
	  strcat(dest,a);
	  strcat(dest," ");        
	  free(a);
	}
}

void concatenateListParameter(char* dest, struct sParameter* sP, sUser* user)
{
        GSList * list= getUserInfo(user,sP->f);
	int i;
        int l=g_slist_length(list);    
	if (l>0)
	{
        	strcat(dest,sP->parameter);
        	strcat(dest," ");        
        	for (i=0;i<l-1;i++)
        	{
                	char * a= g_slist_nth_data(list,i);
                	strcat(dest, a);
                	strcat(dest,",");
        	}    
        	char *a= g_slist_nth_data(list,i);
        	strcat(dest, a);
        	strcat(dest, " ");
	}
	
}

void concatenateParameter(sUser* user, char* dest)
{
    GSList * list=  initializeParameter();
     struct sParameter * p;
      int l=g_slist_length(list);
         for (int i=0;i<l;i++)
	 {
	      p= g_slist_nth_data(list,i);
	   switch (p->type)
	    {
                case TEXT:
                        concatenateTextParameter(dest,p,user);
                        break;
                case LIST:
                        concatenateListParameter(dest,p,user);
                        break;
                case BOOLEAN:
                        concatenateBooleanParameter(dest,p,user);
                        break;
		case INTEGER:
                        concatenateIntegerParameter(dest,p,user);
                        break;
	  }
    } 
    g_slist_foreach(list, (GFunc)free, NULL);
    g_slist_free(list);
   list = NULL;
}
char* generateParameters(sUser* user)
{
  char * ret = malloc(550);
  strcpy(ret, "useradd ");  
 concatenateParameter(user,ret);  
  return ret;
}




