#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include "test.h"
#include "applicationGUI.h"
#include "generateParameter.h"
#include "main.h"
#include "test.h"
const char*  errorString(enum eError error);

int checkExpireDateFormat()
{
  if ((strlen(getTextFromGtkEntry("txtExpireYear"))!=0)&& (strlen(getTextFromGtkEntry("txtExpireMonth"))!=0)&& (strlen(getTextFromGtkEntry("txtExpireDay"))!=0))
  {
    if (strlen(getTextFromGtkEntry("txtExpireYear"))!=4)
    {
      return INCORRECT_YEAR;
    }
    if ((strlen(getTextFromGtkEntry("txtExpireMonth"))<2)
      || ((atoi(getTextFromGtkEntry("txtExpireMonth"))<0) || (atoi(getTextFromGtkEntry("txtExpireMonth"))>12)))
      {
	return INCORRECT_MONTH;
      }
      
      if ((strlen(getTextFromGtkEntry("txtExpireDay"))<2)
	|| ((atoi(getTextFromGtkEntry("txtExpireDay"))<0) || (atoi(getTextFromGtkEntry("txtExpireDay"))>31)))
	
	{
	  return INCORRET_DAY;
	}
	return TEST_OK;
  }
  else
  {
  	return EXPIRE_DATE_EMPTY;
  }
}
int passwordTest()
{
  if ((strlen(getTextFromGtkEntry("txtPassword"))>0) && (strlen(getTextFromGtkEntry("txtPassword"))>0))
  {
    if (strcmp(getTextFromGtkEntry("txtPassword"),getTextFromGtkEntry("txtPassword"))!=0)
    {
      return PASSWORDS_DONT_MATCH;   
    }
    return TEST_OK;
  }
  else
  {
    if ((gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(widgetFromWindow("rbAutoPassword")))) || (!(gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(widgetFromWindow("toggleManyUsers"))))))
      return EMPTY_PASSWORD;
    else
      return TEST_OK;
  }
  
}
int checkMultipleFormat(const char* username)
{
   char* ch;
  ch=(char*)username;
  while ((ch=strchr(ch,'%')))
	{
		ch++;		
		switch (*ch)
		{
		  case 'i':			
				ch++;
				break;
			default:
				return BAD_MULTIPLE_USERNAME;
				break;
		}		
	}
	return TEST_OK;
}
int expireDateTest()
{
  char date[30];
  char systemDate[30];
  int state=checkExpireDateFormat();
  if (state==TEST_OK)
  {        
    sprintf(date,"%04d%02d%02d",atoi(getTextFromGtkEntry("txtExpireYear")),atoi(getTextFromGtkEntry   ("txtExpireMonth")),atoi(getTextFromGtkEntry("txtExpireDay")));
    time_t t = time(NULL);
    struct tm tm = *localtime(&t);
    sprintf(systemDate,"%04d%02d%02d", tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday);
  }
  else
  {
    if (state==EXPIRE_DATE_EMPTY)
    	return TEST_OK; 
    else
    	return EXPIRE_DATE_FAILURE;
  }
  
  if (strcmp(date,systemDate)<0)
  {
    return EXPIRE_DATE_PREVIOUS;
   
  }
  return TEST_OK;
}
int addUser_tests()
{
  int test;
  FILE* f=popen("cat /etc/passwd | cut -d ':' -f1","r");
  char systemNames[30];
  const char *username=getTextFromGtkEntry("txtName");
  while (!(feof(f)))
  {
    fscanf(f,"%s",systemNames);
    if (strcmp(username,systemNames)==0)
    {
      return USERNAME_EXISTS;     
    }
  }
  
  
  test=checkMultipleFormat(username);
  if (test!=TEST_OK)
  {
    return test;
  }
  
  
  test=passwordTest();
  if (test!=TEST_OK)
  {
	return test;
  }
  
  test=expireDateTest();
  if (test!=TEST_OK)
  {
	return test;
  }
 
  
  return TEST_OK;
  
}
int     addManyUsers_tests()
{
   int test;
   const char *str=getTextFromGtkEntry("txtName");
  test=checkMultipleFormat(str);
  if (test!=TEST_OK)
  {
    return test;
  }
   str=getTextFromGtkEntry("txtHomedir");
 
   test=checkMultipleFormat(str);
  if (test!=TEST_OK)
  {
    return BAD_HOME_DIR_FORMAT;
  }
    if (strlen(getTextFromGtkEntry("txtUserNumber"))==0)
  {
  	return NO_NUMBER_OF_USERS; 
  
  }
  if (strcmp(getTextFromGtkEntry("txtStartNumber"),"")==0)
  {
  	return NO_START_NUMBER; 
  
  }

  
  test=passwordTest();
  if (test!=TEST_OK)
  {
	return test;
  }

  if (strchr(getTextFromGtkEntry("txtName"),'%')==NULL)
  {
  	return MANY_USERS_NO_SYMBOL_USERNAME; 
  
  }
  if (strchr(getTextFromGtkEntry("txtHomedir"),'%')==NULL)
  {
  	return MANY_USERS_NO_SYMBOL_HOMEDIR; 
  
  }
  test=expireDateTest();
  if (test!=TEST_OK)
  {
        return test;
  
  }
  return TEST_OK;
}

const char*  errorString(enum eError error)
{
	char* cadena=malloc(250);
	switch (error)
	{
	case PASSWORDS_DONT_MATCH:
		strcpy(cadena,"Las contraseñas introducidas no coinciden");
		break;
	case BAD_USERNAME:
		strcpy(cadena,"El nombre de usuario introducido no es válido");
		break;
	case EXPIRE_DATE_FAILURE:
		strcpy(cadena,"La fecha de expiración introducida no es válida");
		break;
	case INCORRECT_YEAR:
		strcpy(cadena,"El año introducido en la fecha de expiración no es un valor válido");
		break;
	case INCORRECT_MONTH:
		strcpy(cadena,"El mes introducido en la fecha de expiración no es un valor válido");
		break;
	case INCORRET_DAY:
		strcpy(cadena,"El día introducido en la fecha de expiración no es un valor válido");
		break;
	case USERNAME_EXISTS:
		strcpy(cadena,"Ha ingresado un nombre de usuario ya existente");
		break;
	case EXPIRE_DATE_PREVIOUS:
		strcpy(cadena,"Ha ingresado la fecha de expiración incorrectamente");
		break;
	case MANY_USERS_NO_SYMBOL_USERNAME:
		strcpy(cadena,"Se estan agregando muchos usuarios y el nombre de usuario no tiene un caracter autonumérico");
		break;
	case MANY_USERS_NO_SYMBOL_HOMEDIR:
		strcpy(cadena,"Se estan agregando muchos usuarios y el nombre de la carpeta no tiene un caracter autonumérico");
		break;
	case EMPTY_PASSWORD:
		strcpy(cadena,"No ha ingresado una contraseña");
		break;
	case NO_NUMBER_OF_USERS:
		strcpy(cadena,"No ha especificado cuantos usuarios desea agregar");
		break;
	case BAD_MULTIPLE_USERNAME:
		strcpy(cadena,"El nombre de usuario introducido no es válido");
		break;
	case BAD_HOME_DIR_FORMAT:
		strcpy(cadena,"La carpeta introducida no es valida.");
		break;
	case NO_START_NUMBER:
		strcpy(cadena,"No ha introducido un número de inicio");
		break;
	default:
		strcpy(cadena,"Error Desconocido");
		break;
	}
	return cadena;
}

int performTests(int manyUsers)
{
  
  if (manyUsers)  
    return addManyUsers_tests();  
  else  
    return addUser_tests();
  
  return TEST_OK;
  
}

void informError(enum eError error)
{
    char*errString=(char*)errorString(error);
    GtkMessageDialog * errorMessage=(GtkMessageDialog *) gtk_message_dialog_new(NULL, \
    GTK_DIALOG_MODAL , GTK_MESSAGE_ERROR,GTK_BUTTONS_CLOSE,errString);
    gtk_dialog_run((GtkDialog*)errorMessage);
    gtk_widget_destroy ((GtkWidget*)errorMessage);
    free(errString);
}


