#include <stdlib.h>
#include "user.h"

sUser* newUser()
{
      sUser* user= malloc(sizeof(sUser));
      user->UID=-1;
      user->folder=0;
      user->username=0;
       user->encryptedPassword=0;
       user->fullName=0;
       user->name=0;
       user->folder=0;
       user->shell=0;
       user->expireDate=0;
      return user;
}
void setField(sUser* user, void* parameter, int label)
{
        switch (label)
        {
                case USERNAME:
                        setUsername(user,parameter);
                        break;
                case PASSWORD:
                        setPassword(user,parameter);
                        break;
                case FOLDER:
                        setFolder(user,parameter);
                        break;
                case FULLNAME:
                        setFullName(user,parameter);
                        break;
                case CREATEFOLDER:
                        setCreateFolder(user,parameter);                
                        break;
                case GROUPS:
                        setGroupsList(user,parameter);                
                        break;                
                case SHELL:
                        setShell(user,parameter);
                        break;                
                case UID:
                        setUID(user,parameter);
                        break;                
                case UNIQUEID:
                        setUniqueUID(user,parameter);
                        break;                
                case CREATEUSERGROUP:
                        setCreateUserGroup(user,parameter);
                        break;                
                case EXPIREDATE:
                        setExpireDate(user,parameter);
                        break;                
       }
}
void assignString(char** dest, char* orig)
{
	int n;
	n=strlen(orig);
        if (*dest!=0)
        {
                free((char*)(*dest));
        }
	
        *dest=malloc(n+10);
        strcpy(*dest,orig);        

}
void setUsername(sUser* user, char * aUsername)
{
        assignString(&user->username,aUsername);
}
void setPassword(sUser* user, char * aEncryptedPassword)
{
        assignString(&user->encryptedPassword,aEncryptedPassword);        
}
void setFullName(sUser* user, char * aFullName)
{
        assignString(&user->fullName,aFullName);    
}
void setFolder(sUser* user, char* folder)
{
        assignString(&user->folder,folder);    
}
void setShell(sUser* user, char* shell)
{
        assignString(&user->shell,shell);    
}

void setCreateFolder(sUser* user, int* createFolder)
{
          user->createFolder=*createFolder;    
}
void setGroupsList(sUser* user,  GSList* groups)
{
          user->groups=groups;    
}
void setUID(sUser* user, int* UID)
{
          user->UID=*UID;    
}
void setUniqueUID(sUser* user, int* uUID)
{
          user->uniqueUID=*uUID;    
}
void setCreateUserGroup(sUser* user, int* createUserGroup)
{
          user->createUserGroup=*createUserGroup;    
}
void setExpireDate(sUser* user, char* expireDate)
{
        assignString(&user->expireDate,expireDate);    
}
void deleteUser(sUser*user)
{
       free(user->username);
       free(user->encryptedPassword);
       free(user->fullName);
       free(user->name);
       free(user->folder);
       g_slist_foreach(user->groups,(GFunc) free, NULL);
       g_slist_free(user->groups);
       user->groups = NULL;
       free(user->shell);
       free(user->expireDate);
}
int getUserInfoI(sUser* user, enum field f)
{
       switch (f)
        {
                case CREATEFOLDER:
                        return user->createFolder;
                        break;
                case UID:
                        return user->UID;
                        break;                
                case UNIQUEID:
                        return user->uniqueUID;
                        break;                
                case CREATEUSERGROUP:
                        return user->createUserGroup;
                        break;               
                             
                default:
                        return -1;
                        break;
       }
}
void * getUserInfo(sUser* user, enum field f)
{
        switch (f)
        {
                case USERNAME:
                        return user->username;
                        break;
                case PASSWORD:
                        return user->encryptedPassword;
                        break;
                case FULLNAME:
                       return user->fullName;
                        break;
                case FOLDER:
                        return user->folder;
                        break;
                case CREATEFOLDER:
                        return &user->createFolder;
                        break;
                case GROUPS:
                        return user->groups;
                        break;                
                case SHELL:
                        return user->shell;
                        break;                
                case UID:
                        return &user->UID;
                        break;                
                case UNIQUEID:
                        return &user->uniqueUID;
                        break;                
                case CREATEUSERGROUP:
                        return &user->createUserGroup;
                        break;                
                case EXPIREDATE:
                        return user->expireDate;
                        break;                
		default:
		    return 0;
		  break;
       }
       
}
