#include <stdlib.h>
#include "applicationGUI.h"
#include "gui/support.h"
#include "widgetOperations.h"
#include "generateParameter.h"
#include "user.h"





widgetOp* widget_operation_init(GtkWidget* parent, GtkWidget* widget, char* (*parseGUI)(gchar*), int widgetType, int field)
{
  	widgetOp* wOp=malloc(sizeof(widgetOp));
  	wOp->parent=parent;
        wOp->widget= widget;
	wOp->parseGUI=parseGUI;
	wOp->widgetType=widgetType;
	wOp->field=field;
	return wOp;
}
GSList* initializeList()
{
        return 0;
}
void addNewOperation(GSList** lo,GtkWidget*parent,GtkWidget* widget, gchar* (*parseGUI)(gchar*), int widgetType, int field)
{
        widgetOp* wOp=widget_operation_init(parent,widget,parseGUI,widgetType,field);
        addOperation(lo,wOp);
}
void addOperation(GSList** lo,widgetOp* wOp)
{
  
  *lo=g_slist_append(*lo, (gpointer)wOp);
}

GSList * createMemberFromContainer(GtkContainer *widget, widgetOp* wOp)
{
  int pos;
  GtkButton* b;
  GSList * names=NULL;
     
  GList* l=gtk_container_get_children((GtkContainer*) widget);
  for (pos=0; pos<g_list_length(l); pos++)
  {
    b=g_list_nth_data(l,pos);
    char *groupNameTemp;
    if  (gtk_toggle_button_get_active((GtkToggleButton*) b))
    {
      groupNameTemp=malloc(strlen((char*) gtk_button_get_label(GTK_BUTTON(g_list_nth_data(l,pos)))));
      strcpy(groupNameTemp,(char*) gtk_button_get_label(GTK_BUTTON(g_list_nth_data(l,pos))));
            
      names=g_slist_append(names,groupNameTemp);      
    }
  }
 return names;

}
void* parseOperation(widgetOp* wOp)
{

  GtkWidget*  widget= wOp->widget;
  GtkWidget* temp;
  switch (getWidgetType(wOp))
  {
     int * t;
     gchar* a;
      int * intret;

    case GTKENTRY:
      if (wOp->parseGUI!=0)
      {
        char* a=(gchar*) wOp->parseGUI((gchar*) gtk_entry_get_text((GtkEntry*)widget));
      	return a;
      }
      else
      {
      	gchar* a= (gchar*) gtk_entry_get_text((GtkEntry*)widget);
	char* ret= malloc(strlen(a));
	strcpy(ret,a);
	return ret;
	
      } 

      break;
    case GTKCONTAINER:
       return createMemberFromContainer((GtkContainer*) widget, wOp);
      break;
    case GTKCHECKBUTTON:
        t=malloc(sizeof(int));
      if (gtk_toggle_button_get_active ( (GtkToggleButton*)widget)) 
         *t=1;
     else
        *t=0;
     return t;
      break;
   case GTKDIALOG:
	temp=wOp->parent;
	gint result = gtk_dialog_run (GTK_DIALOG (temp));
	switch (result)
	  {
           case GTK_RESPONSE_ACCEPT:
		  return (void*)gtk_entry_get_text((GtkEntry*)wOp->widget);	  
  	   	   	   	  
     	          break;
	   default:
	        
        	break;
	  }
	  break; 
    case GTKENTRYINTEGER:
      if (wOp->parseGUI!=0)
             a=(gchar*) wOp->parseGUI((gchar*) gtk_entry_get_text((GtkEntry*)widget));
      else      
      	a=  (gchar*) gtk_entry_get_text((GtkEntry*)widget);
      intret= malloc(sizeof(int));
      if (strcmp(a,""))      
       *intret=atoi(a);
      else
	*intret=-1;
      return intret;
	     
  }
  return 0;
}

sUser* createUser(int optionsSelected)
{
    GSList* operations= initialize_widgets_operations(optionsSelected);
    sUser* user= newUser();
    int l=g_slist_length(operations);    
    for (int i=0;i<l;i++)
    {
        widgetOp* wOp=  g_slist_nth_data (operations,i);
        char* field=parseOperation(wOp);
        setField(user, field,wOp->field);  
	if (getWidgetType(wOp)!=GTKCONTAINER)     
		free(field);
    }
    g_slist_foreach(operations,(GFunc) free, NULL);
    g_slist_free(operations);
    operations = NULL;
    return user;

}
int getWidgetType(widgetOp* wOp)
{
        return wOp->widgetType;
}
